package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.NetConnection;
	import flash.net.ObjectEncoding;
	import flash.net.Responder;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.utils.getTimer;
	
	import it.alittleb.pyamf.LoadImagesFromByteArray;
	import it.alittleb.pyamf.LoadImagesFromStringArray;

	public class TestLoadImageFromPyAMF extends Sprite
	{
		private var nc: NetConnection;
		private var responder1: Responder;
		private var responder2: Responder;
		
		private var ticktime: Number;
		private var textfield: TextField;
		private var container: Sprite;
		
		public function TestLoadImageFromPyAMF( )
		{
			responder1 = new Responder( onResult, onFault );
			responder2 = new Responder( onResult2, onFault );
			
			nc = new NetConnection( );
			nc.objectEncoding = ObjectEncoding.AMF3;
			nc.connect("http://localhost:8000");
			
			textfield = new TextField( );
			textfield.border = true;
			textfield.borderColor = 0xFFFFFF;
			textfield.autoSize = TextFieldAutoSize.LEFT;
			textfield.multiline = true;
		
			container = new Sprite( );
		
			addChild( container );	
			addChild( textfield );

		
			test1( );
		}
		
			private function log( t: String ): void
			{
				textfield.text += t + "\n";
				trace(t);
			}
			
			private function get elapsed( ): Number
			{
				var t: Number = getTimer( );
				return t - ticktime;
			}
			
			private function reset( ): void
			{
				ticktime = getTimer( );
			}
			
			private function test1( ): void
			{
				log('[' + ( getTimer( ) ) + '] call.test1');
				nc.call("test.getStringImages", responder1 );
				reset( );
			}
			
			private function onResult( result: Array ): void
			{
				log('[' + getTimer( ) + '] result.test1, elapsed: ' + elapsed );
				reset( );
				var test: LoadImagesFromStringArray = new LoadImagesFromStringArray( result );
				test.addEventListener( Event.COMPLETE, onFirstTestComplete );
				container.addChild( test );
			}
			
			private function onFault( info: Object ): void
			{
				
			}

			private function onFirstTestComplete( event: Event ): void
			{
				log('[' + getTimer( ) + '] complete.test1, elapsed: ' + elapsed );
				//container.removeChild( event.target as Sprite );
				
				log('----------');
				test2( );
			}
			
			private function test2( ): void
			{
				log('[' + getTimer() + '] call.test2');
				
				nc.call("test.getDataImages", responder2 );
				reset( );
			}
			
			private function onResult2( result: Array ): void
			{
				log('[' + getTimer() + '] result.test2, elapsed: ' + elapsed );
				reset( );
				var test: LoadImagesFromByteArray = new LoadImagesFromByteArray( result );
				test.x = 5;
				test.y = 5;
				test.addEventListener( Event.COMPLETE, onSecondTestComplete );
				container.addChild( test );
			}
			
			private function onSecondTestComplete( event: Event ): void
			{
				log('[' + getTimer() + '] complete.test2, elapsed: ' + elapsed );
				//container.removeChild( event.target as Sprite );
			}
	}
}
